export declare enum DateFormat {
    forwardSlashMMDDYYYY = "MM/DD/YYYY",
    dashMMDDYYYY = "MM-DD-YYYY",
    forwardSlashDDMMYYYY = "DD/MM/YYYY"
}
export declare class Dates {
    private dateSymbol;
    private dateFormat;
    private date;
    private day;
    private month;
    private year;
    private formatDates;
    constructor();
    /**
     * Set the format of your dates
     */
    setFormat(dateFormat: DateFormat): void;
    /**
     * get the format
     */
    getFormat(): any;
    /**
     * get the today's date
     */
    today(): {
        first: any;
        last: any;
        date?: undefined;
    } | {
        date: any;
        first?: undefined;
        last?: undefined;
    };
    /**
     * get the yesterday's date
     */
    yesterday(): {
        first: any;
        last: any;
        date?: undefined;
    } | {
        date: any;
        first?: undefined;
        last?: undefined;
    };
    /**
     * get the current week first and last date
     */
    currentWeek(): {
        first: any;
        last: any;
        date?: undefined;
    } | {
        date: any;
        first?: undefined;
        last?: undefined;
    };
    /**
     * get the current month first and last date
     */
    currentMonth(): {
        first: any;
        last: any;
        date?: undefined;
    } | {
        date: any;
        first?: undefined;
        last?: undefined;
    };
    /**
     * get the next month first and last date
     */
    nextMonth(): {
        first: any;
        last: any;
        date?: undefined;
    } | {
        date: any;
        first?: undefined;
        last?: undefined;
    };
    /**
     * get the next week first and last date
     */
    nextWeek(): {
        first: any;
        last: any;
        date?: undefined;
    } | {
        date: any;
        first?: undefined;
        last?: undefined;
    };
    /**
     * get the last week first and last date
     */
    lastWeek(): {
        first: any;
        last: any;
        date?: undefined;
    } | {
        date: any;
        first?: undefined;
        last?: undefined;
    };
    /**
     * get the next thirty days date
     */
    nextThirtyDays(): {
        first: any;
        last: any;
        date?: undefined;
    } | {
        date: any;
        first?: undefined;
        last?: undefined;
    };
    /**
     * get the last seven days date
     */
    lastSevenDays(): {
        first: any;
        last: any;
        date?: undefined;
    } | {
        date: any;
        first?: undefined;
        last?: undefined;
    };
    /**
     * get the last thirty days date
     */
    lastThirtyDays(): {
        first: any;
        last: any;
        date?: undefined;
    } | {
        date: any;
        first?: undefined;
        last?: undefined;
    };
    /**
     * get the last sixty days date
     */
    lastSixtyDays(): {
        first: any;
        last: any;
        date?: undefined;
    } | {
        date: any;
        first?: undefined;
        last?: undefined;
    };
    /**
     * get the last ninety days date
     */
    lastNinetyDays(): {
        first: any;
        last: any;
        date?: undefined;
    } | {
        date: any;
        first?: undefined;
        last?: undefined;
    };
    /**
     * get the first day of the month and current day
     */
    monthToDate(): {
        first: any;
        last: any;
        date?: undefined;
    } | {
        date: any;
        first?: undefined;
        last?: undefined;
    };
    /**
    * get the last month first and last day
    */
    lastMonth(): {
        first: any;
        last: any;
        date?: undefined;
    } | {
        date: any;
        first?: undefined;
        last?: undefined;
    };
    /**
     * increment day by specific days
     */
    incrementBy(num: any): {
        first: any;
        last: any;
        date?: undefined;
    } | {
        date: any;
        first?: undefined;
        last?: undefined;
    };
    /**
     * decrement day by specific days
     */
    decrementBy(num: any): {
        first: any;
        last: any;
        date?: undefined;
    } | {
        date: any;
        first?: undefined;
        last?: undefined;
    };
    private resultDateFormat;
    private dateFormatting;
    private formatMonthAndDay;
    private retrieveDates;
}
