"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var dates_1 = require("./dates");
var Filter = /** @class */ (function () {
    /**
     * add your object
     */
    function Filter(arrOfObj) {
        this.userArrOfObj = arrOfObj;
        this.date = new dates_1.Dates();
    }
    /**
     * filter by attribute and value
     */
    Filter.prototype.filterBy = function (attribute, value) {
        this.finalResult = this.userArrOfObj.filter(function (filterByAtt) { return filterByAtt[attribute] == value; });
        return this;
    };
    /**
     * compound filters more info in readme
     */
    Filter.prototype.where = function (attribute, operator, value) {
        if (typeof this.finalResult === "undefined") {
            this.compoundFilter(attribute, operator, value, this.userArrOfObj);
        }
        else {
            this.compoundFilter(attribute, operator, value, this.finalResult);
        }
        return this;
    };
    /**
     * returns the filtered list
     */
    Filter.prototype.result = function () {
        return this.finalResult;
    };
    Filter.prototype.compoundFilter = function (attribute, operator, value, obj) {
        if (operator == "==") {
            this.finalResult = obj.filter(function (filterByAtt) { return filterByAtt[attribute] == value; });
        }
        else if (operator == "!=") {
            this.finalResult = obj.filter(function (filterByAtt) { return filterByAtt[attribute] != value; });
        }
        else if (operator == "<=") {
            this.finalResult = obj.filter(function (filterByAtt) { return filterByAtt[attribute] <= value; });
        }
        else if (operator == ">=") {
            this.finalResult = obj.filter(function (filterByAtt) { return filterByAtt[attribute] >= value; });
        }
        else {
            throw new Error("Invalid operator used, please use the following operators: ==, >=, <=, !=");
        }
    };
    /**
     * set date format
     */
    Filter.prototype.setDateFormat = function (format) {
        this.date.setFormat(format);
    };
    /**
    *  get date format
    */
    Filter.prototype.getDateFormat = function () {
        return this.date.getFormat();
    };
    Filter.prototype.filterByToday = function (attribute) {
        this.dateResult = this.date.today();
        this.filterDates(attribute, this.dateResult.date);
        return this;
    };
    Filter.prototype.filterByYesterday = function (attribute) {
        this.dateResult = this.date.yesterday();
        this.filterDates(attribute, this.dateResult.date);
        return this;
    };
    Filter.prototype.filterByCurrentWeek = function (attribute) {
        this.dateResult = this.date.currentWeek();
        this.filterDates(attribute, this.dateResult);
        return this;
    };
    Filter.prototype.filterByCurrentMonth = function (attribute) {
        this.dateResult = this.date.currentMonth();
        this.filterDates(attribute, this.dateResult);
        return this;
    };
    Filter.prototype.filterByNextWeek = function (attribute) {
        this.dateResult = this.date.nextWeek();
        this.filterDates(attribute, this.dateResult);
        return this;
    };
    Filter.prototype.filterByNextMonth = function (attribute) {
        this.dateResult = this.date.nextWeek();
        this.filterDates(attribute, this.dateResult);
        return this;
    };
    Filter.prototype.filterByLastWeek = function (attribute) {
        this.dateResult = this.date.lastWeek();
        this.filterDates(attribute, this.dateResult);
        return this;
    };
    Filter.prototype.filterByNextThirtyDays = function (attribute) {
        this.dateResult = this.date.nextThirtyDays();
        this.filterDates(attribute, this.dateResult);
        return this;
    };
    Filter.prototype.filterByLastSevenDays = function (attribute) {
        this.dateResult = this.date.lastSevenDays();
        this.filterDates(attribute, this.dateResult);
        return this;
    };
    Filter.prototype.filterByLastThirtyDays = function (attribute) {
        this.dateResult = this.date.lastThirtyDays();
        this.filterDates(attribute, this.dateResult);
        return this;
    };
    Filter.prototype.filterByLastSixtyDays = function (attribute) {
        this.dateResult = this.date.lastSixtyDays();
        this.filterDates(attribute, this.dateResult);
        return this;
    };
    Filter.prototype.filterByLastNinetyDays = function (attribute) {
        this.dateResult = this.date.lastNinetyDays();
        this.filterDates(attribute, this.dateResult);
        return this;
    };
    Filter.prototype.filterByMonthToDate = function (attribute) {
        this.dateResult = this.date.monthToDate();
        this.filterDates(attribute, this.dateResult);
        return this;
    };
    Filter.prototype.filterByLastMonth = function (attribute) {
        this.dateResult = this.date.lastMonth();
        this.filterDates(attribute, this.dateResult);
        return this;
    };
    Filter.prototype.dateFilter = function (att, date) {
        if (typeof this.finalResult === "undefined") {
            this.finalResult = this.userArrOfObj.filter(function (filterByDate) { return new Date(filterByDate[att]).toDateString() == new Date(date).toDateString(); });
        }
        else {
            this.finalResult = this.finalResult.filter(function (filterByDate) { return new Date(filterByDate[att]).toDateString() == new Date(date).toDateString(); });
        }
    };
    Filter.prototype.filterDates = function (att, date) {
        if (typeof date.last != "undefined") {
            if (typeof this.finalResult === "undefined") {
                this.finalResult = this.userArrOfObj.filter(function (filterByDate) { return new Date(filterByDate[att]) >= new Date(date.first) && new Date(filterByDate[att]) <= new Date(date.last); });
            }
            else {
                this.finalResult = this.finalResult.filter(function (filterByDate) { return new Date(filterByDate[att]) >= new Date(date.first) && new Date(filterByDate[att]) <= new Date(date.last); });
            }
        }
        else {
            this.dateFilter(att, date);
        }
    };
    /**
     * returns user array of object
     */
    Filter.prototype.toString = function () {
        return this.userArrOfObj;
    };
    return Filter;
}());
exports.Filter = Filter;
